Start of change

V12R1Mnnn application compatibility levels for data server clients and drivers

IBM® data server clients and drivers that use Db2 for z/OS® capabilities with a function level requirement of greater than V12R1M500 require extra program preparation steps.

Before you begin

Take these actions on the clients that connect to your Db2 for z/OS system:

  • Upgrade data server clients and drivers to the following levels so that they can exploit Db2 for z/OS function-level application compatibility of greater than V12R1M500:
    • IBM Data Server Driver for JDBC and SQLJ: Versions 3.72 and 4.22, or later
    • Start of changeOther IBM data server clients and drivers: Db2 for Linux®, UNIX, and Windows, Version 11.1 Fix Pack 1, or laterEnd of change
  • Run the db2connectactivate utility to activate the Version 11.1 license certificate file for Db2 Connect Unlimited Edition on Db2 for z/OS. Specify the options to bind the driver and client packages into the NULLID collection, with APPLCOMPAT V12R1M500. For example:
    db2connectactivate.sh -host sys1.svl.ibm.com -port 5021 -database STLEC1 -user dbadm 
    -password dbadmpass -bindoptions "APPLCOMPAT V12R1M500" -collection NULLID

About this task

This procedure sets the V12R1Mnnn application compatibility for a client or driver that needs to utilize server capabilities that require an application compatibility of greater than V12R1M500. If the client or driver does not utilize the capabilities of a new function level, you do not need to update its application compatibility settings.

Procedure

  1. Start of change Set the Db2 for z/OS server application compatibility (APPLCOMPAT) level.
    1. For client applications that contain static SQL statements, rebind the static application packages with the new APPLCOMPAT value, on the client and on the server.
    2. For client applications that contain only dynamic SQL statements, bind or rebind the client or driver packages with the new APPLCOMPAT value, on the server.
      Tip: Binding package copies and keeping the original driver packages lets you access new capabilities for applications that need them, while ensuring stability for applications that should not be exposed to incompatibilities.

      For drivers only, you can use jobs that are provided with Db2 for z/OS, in data set prefix.SDSNSAMP, to bind or rebind the driver packages on the server. To run those jobs, follow these steps:

      1. Customize jobs DSNTIJLC and DSNTIJLR, using the instructions in the job prologs.
      2. If there is a possibility that you still need to run applications under a driver that is at the old application compatibility level, run DSNTIJLC to bind copies of the driver packages at the new application compatibility level, while leaving the packages in the NULLID collection at the old application compatibility level. In most cases, you should do this.

        If you are sure that you do not need to run applications under a driver at the old application compatibility level, run job DSNTIJLR to rebind the client or driver packages at the new application compatibility level.

      3. If you bound copies of the driver packages for the new function level, switch the drivers to the new function level by modifying the property that controls the current package set to match the collection ID of the new package copies.
        • For CLI or ODBC drivers, change the CLI/ODBC CurrentPackageSet configuration keyword value.
        • For the IBM Data Server Driver for JDBC and SQLJ, change the DB2BaseDataSource.currentPackageSet Connection or DataSource property value.
    End of change
  2. Start of changeSet the client application compatibility value to control the capabilities of client applications when a client or driver contains changes that enable new server capabilities. If you set the client application compatibility level, its value must be less than or equal to the server application compatibility level.End of change

    Take one of the following actions to set the client application compatibility value.

End of change